let timeout = 3600 * 1000; //1 hour
let _tasks=[];
let _idle=1000;
let _lastHeartbeatTime=new Date().getTime();
let _tabId=null;
let _started=false;
let _host="https://amz.antcoor.net";


// setInterval(function() {
// 	if(_started) {
// 		if(new Date().getTime()-_lastHeartbeatTime>180*1000&&_tabId!=null) {
// 			console.log('心跳超时，刷新页面');
// 			chrome.tabs.query({active:true,windowType:"normal", currentWindow: true},function(d){
// 				chrome.tabs.reload(d[0].id);
// 			})
// 		}
// 	}
// },15000);

chrome.runtime.onMessage.addListener(function (request, sender, sendResponse) {
	if(sender.tab) {
		_tabId=sender.tab.id;
	}
	switch(request.cmd) {
		case 'start':
			_started=true;
			break;
		case 'stop':
			_started=false;
			break;	
		case 'getSpiderTasks':
			$.ajax({
				url:_host+'/plugin/get-product-ext-info-tasks?host='+request.host,
				type:"GET",
				contentType:"application/json; charset=utf-8",
				dataType:"json",
				tryCount : 0,
				retryLimit : 3,
				success: function(rs){
					sendMessageToContentScript(sender.tab.id,{cmd:'getSpiderTasksResult',code:rs.code,data:rs.data});
				},
				error : function(xhr, textStatus, errorThrown ) {
					this.tryCount++;
					if (this.tryCount <= this.retryLimit) {
						//try again
						console.log('失败重试');
						let me=this;
						setTimeout(function() {
							$.ajax(me);
						},1000);
					} else {
						sendMessageToContentScript(sender.tab.id,{cmd:'getSpiderTasksResult',code:1});
					}						
				}
			});
			break;
		case 'updateSpiderTask':
			_lastHeartbeatTime=new Date().getTime();
			$.ajax({
				url:_host+'/plugin/update-product-ext-info',
				type:"POST",
				data:JSON.stringify(request.data),
				contentType:"application/json; charset=utf-8",
				dataType:"json",
				tryCount : 0,
				retryLimit : 3,
				success: function(rs){
					sendMessageToContentScript(sender.tab.id,{cmd:'updateSpiderTaskResult',code:rs.code,data:request.data});
				},
				error : function(xhr, textStatus, errorThrown ) {
					this.tryCount++;
					if (this.tryCount < this.retryLimit) {
						//try again
						console.log('失败重试');
						let me=this;
						setTimeout(function() {
							$.ajax(me);
						},1000);
					} else {
						sendMessageToContentScript(sender.tab.id,{cmd:'updateSpiderTaskResult',code:1});
					}						
				}
			});
			break;
		default:
			break;
    }
	sendResponse('ok');
});

//主动发送消息给后台
function sendMessageToRuntime(message, callback) {
    chrome.runtime.sendMessage(message, callback || function (response) {
        console.log('收到回复：' + response);
    });
}

function sendMessageToContentScript(tabId, message, callback) {
    chrome.tabs.sendMessage(tabId, message, function (response) {
        if (callback) callback(response);
    });
}