let initPanel = false;
let _started=false;
let _tasks=[];
let _idle=2000;
let _autoStart=false;
let _startTime=0;

let pi={};

let _count=0;

document.addEventListener('DOMContentLoaded', function () {
    let s = document.createElement('script');
    s.text = "function markFeatureRenderForImageBlock() {} function setCSMReq() {}";
    s.onload = function() {
        this.remove();
    };
    (document.head || document.documentElement).appendChild(s);
    initCustomPanel();
});

function initCustomPanel() {
    chrome.storage.sync.get(['autoStart'],function(v) {
        let autoStart=false;
        if(v.autoStart&&v.autoStart=='true') {
            autoStart=true;
        }

        if($('.antcoor-cpc-center').length==0) {
            $(document.body).append('<div class="antcoor-cpc-center"><div class="ac-button ac-button-start"><i class="fa fa-'+(autoStart?'pause':'play')+'"></i></div></div>');
            $('.antcoor-cpc-center .ac-button-start').click(function() {
                if($(this).find('.fa-play').length>0) {
                    $(this).html('<i class="fa fa-pause"></i>');
                    startScrapy();
                } else {
                    $(this).html('<i class="fa fa-play"></i>');
                    stopScrapy();
                }
            });
        }
        if(autoStart) {
            startScrapy();
        }

    });

}

function markFeatureRenderForImageBlock() {

}

function startScrapy() {
	chrome.storage.sync.set({autoStart:"true"},function() {});
	_startTime=new Date().getTime();
	_started=true;
	doScrapy();
	sendMessageToBackground({cmd:'start'});
}

function doScrapy() {
	if(new Date().getTime()-_startTime>2*3600*1000) {
		//window.location.reload();
		//return;
	}
	if(_tasks.length==0) {
        if(_count>99) {
            window.location.reload();
            return;
        }
		if(_started) {
			sendMessageToBackground({cmd:'getSpiderTasks',host:window.location.hostname});
			return;
		}
        return;
	}
	let task=_tasks.shift();
	_count++;
    if(_count%100==99) {
        console.clear();
    }
    pi={id:task.id};
    pi.asin=task.asin;
    pi.hostname=location.hostname;
	if(_started) {
		$.ajax({
			type:'GET',
			url:'https://'+location.hostname+'/dp/'+task.asin,
			tryCount : 0,
			retryLimit : 2,
			success: function(rs){
				parseHtml(rs);
			},
			error : function(xhr, textStatus, errorThrown ) {
                if(xhr.status==404) {
                    //util.log('页面404:'+this.url);
                    pi.code=1;
                    sendMessageToBackground({cmd:'updateSpiderTask',data:pi});
                    return;
                } else if(xhr.status==503) {
                    //亚马逊屏蔽
                    util.log('触发验证策略,亚马逊禁止访问');
                    stopScrapy();
                    setTimeout(function() {
                        startScrapy();
                    },300000);
                    return;
                }
				this.tryCount++;
				if (this.tryCount < this.retryLimit) {
					//try again
					util.log('失败重试');
					let me=this;
					setTimeout(function() {
						$.ajax(me);
					},2000);
				} else {
                    pi.code=1;
					sendMessageToBackground({cmd:'updateSpiderTask',data:pi});
				}					
			}
		});
	}
}

function stopScrapy() {
    chrome.storage.sync.set({autoStart:"false"},function() {
    });
    _started=false;
    sendMessageToBackground({cmd:'stop'});
}
    
function getOrCreatePanel(id,cb,left,width,ttop,height) {
    if ($('.antcool-bg-div').length == 0 && initPanel == false) {
        initPanel = true;
        let content = '<div id="'+id+'" class="antcoor-bg-div"></div>' +
            '<div id="antcoor-plugin-panel" style="'+(left?'left:'+left+';':' ')+(width?'width:'+width+';':' ')+(ttop?'top:'+ttop+';':' ')+(height?'height:'+height+';':' ')+'">' +
            '  <div class="ac-close-btn"><i class="antcoor-fa fa-remove"></i></div>' +
            '  <div class="ac-panel-main">' +
            '  </div>' +
            '</div>';
        $(content).appendTo('body');
        $('#antcoor-plugin-panel .ac-close-btn').click(function () {
            $('.antcoor-bg-div').hide();
            $('#antcoor-plugin-panel').hide();
        });
        $(window).resize(function () {
            $('.ac-acp-body').height($('#antcoor-plugin-panel').height() - 160);
        });
        $('.ac-acp-body').height($('#antcoor-plugin-panel').height() - 160);
        cb();
    } else {
        cb();
    }
}

function parseHtml(html) {
	let doc=$(html).error(function() {
        console.log(arguments);
    });
	let langIndex=html.indexOf('lang="');
	let endIndex=html.indexOf('"',langIndex+6);
	pi.lang=html.substring(langIndex+6,endIndex);
	//pi.asin=doc.find('#ASIN').val();
	getProductBaseInfo(doc);
    parseReview(doc);
    //parsePrice(doc);
    parseAmazonChoice(doc);
    util.log(pi);
    sendMessageToBackground({cmd:'updateSpiderTask',data:pi});
    doc.remove();
    // getReviewTag(doc,function() {
    //     util.log(pi);
    //     sendMessageToBackground({cmd:'updateSpiderTask',data:pi});
    //     doc.remove();
    // });
}

function parseReview(doc) {
    let title = doc.find("#acrPopover").attr("title");
    if (title) {
        let matcher=title.match(/\d[,\.]\d/);
        if (matcher) {
            let num = util.parseLocaleNumber(matcher[0], pi.lang);
            pi.star=num;
        }
    }
    let reviewCount = doc.find("#acrCustomerReviewText").text();
    if (reviewCount) {
        let matcher=reviewCount.match(/[\d,\.]*/);
        if (matcher) {
            let num = util.parseLocaleNumber(matcher[0], pi.lang);
            pi.reviewCount=num;
        }
    }
}

function getProductBaseInfo(doc) {
    pi.title=doc.find('#productTitle').text().trim();
    let seller=doc.find('#sellerProfileTriggerId');
    if(seller.length==0) {
        seller=doc.find('#merchant-info a:eq(0)');
        if(seller.length==0) {
            seller=doc.find('#tabular-buybox a');
        }
        let _sellerLink=null;
        let found=false;
        if(seller.length>0) {
            seller.each(function(i,e) {
                if(!found&&$(e).attr('href').indexOf('/sp?marketplaceID=')!=-1) {
                    _sellerLink=$(e).attr('href');
                    found=true;
                }
            });
        } 
        if(_sellerLink==null) {
            let soldBy=doc.find('#tabular-buybox .tabular-buybox-text:eq(1) span').text();
            if(!soldBy) {
                soldBy=doc.find('#shipFromSoldByAbbreviated_feature_div > #sfsb_accordion_head .a-row:nth-child(1) span:eq(1)').text();
            }
            if(!soldBy) {
                let text= doc.find('#merchant-info span:eq(0)').text();
                let matcher=text.match(/(Amazon(\.\w+)*)/g);
                if(matcher&&matcher.length>0) {
                    soldBy=matcher[0];
                }
            }
            if(!soldBy) {
                let text=$('#tabular-buybox .tabular-buybox-text:eq(1)').text();
                let matcher=text.match(/(Amazon(\.\w+)*)/g);
                if(matcher&&matcher.length>0) {
                    soldBy=matcher[0];
                }
            }
            pi.soldBy=soldBy;
        } else {
            pi.soldBy=seller.text();
        }
        pi.sellerLink=_sellerLink;
    } else {
        pi.sellerLink=seller.attr('href');
        pi.soldBy=seller[0].innerText;
    }
    let mainDetail=[];
    mainDetail=mainDetail.concat(doc.find('.detail-bullet-list>li span.a-list-item>span:nth-child(2)').toArray());
    mainDetail=mainDetail.concat(doc.find('.prodDetTable tr td').toArray());

    $.each(mainDetail,function(i,e) {
        let text=$(e).text().trim();
        if(text.match(/^[A-Z0-9]{10}$/)) { //asin
            //util.log('ASIN:'+text+'?');
            return;
        }
        if(text.match(/.+x.+x/)) { //size
            return;
        }
        if(getAvailableDateFromTable(doc,text)) return;
        //if(getBrandFromTable(doc,text)) return;
    });

    let nodePath='';
    doc.find('#wayfinding-breadcrumbs_feature_div ul li a ').each(function(i,e) {
        nodePath+=' > '+$(e).text().trim();
    });
    pi.nodePath=nodePath.replace(/^\s>\s/,'');
}

function parseAmazonChoice(doc) {
    let html = doc.find("#acBadge_feature_div").html();
    if (html&&html.indexOf("amazons-choice-popover")!= -1) {
        pi.amazonChoice=true;
    } else {
        pi.amazonChoice=false;
    }
}


function getAvailableDateFromTable(doc,text) {
    if(!/[12]\d{3}/.test(text)||text.length<8||/^\d+$/.test(text)) {
        return false;
    }
    let dateText=text.replace(/\u200e/g,'').trim();
    let match=dateText.match(/\((.+)\)/);
    if(match) {
        dateText=match[1];
    }
    if(pi.lang.split('-')[0]=='en') {
        moment.months().every(function(e) {
            let abbr=e.substring(0,3);
            if(dateText.indexOf(e)==-1&&dateText.indexOf(abbr)!=-1) {
                dateText=dateText.replace(new RegExp(abbr+"[a-zA-Z\\.]?"),e);
                return false;
            }
            return true;
        });
    }
    let dt=moment(dateText.replace('.',''), util.getLocaleDateFormat(pi.lang),pi.lang.split('-')[0],true);
    if(dt.isValid()&&dt.year()<=new Date().getFullYear()) {
        let currDate=pi.firstAvailableDate;
        if(currDate) {
            if(dt.isBefore(moment(currDate,'YYYY/MM/DD'))) {
            	pi.firstAvailableDate=dt.format('YYYY/MM/DD');
            }
        } else {
        	pi.firstAvailableDate=dt.format('YYYY/MM/DD');
        }
        return true;
    }
    return false;
}



//主动发送消息给后台
function sendMessageToBackground(message, callback) {
    chrome.runtime.sendMessage(message, callback || function (response) {
        //util.log('收到来自后台的回复：' + response);
    });
}


// 接收来自后台的消息
chrome.runtime.onMessage.addListener(function (request, sender, sendResponse) {
    //util.log('收到来自 ' + (sender.tab ? "content-script(" + sender.tab.url + ")" : "popup或者background") + ' 的消息：', request);
    switch (request.cmd) {
		case 'getSpiderTasksResult':
			if(request.code==0) {
				_tasks=request.data;
				if(_tasks.length==0) {
					util.log('没有抓取任务');
					setTimeout(function() {
						doScrapy();
					},10000);
				} else {
                    util.log('收到新任务数:'+_tasks.length);
					doScrapy();
				}
			} else {
				doScrapy();
			}
			sendResponse('ok');
			break;
		case 'updateSpiderTaskResult':
			util.log('Update spider task result : asin='+pi.asin+',result='+request.code+',count='+_count);
			if(_started) {
				setTimeout(doScrapy,_idle*(1+Math.random()*5));
			}
			sendResponse('ok');
			break;	
		default:
			break;
	}
});