;(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? module.exports = factory() :
        typeof define === 'function' && define.amd ? define(factory) :
            global.util = factory()
}(this, (function () {
    'use strict';
    Date.prototype.format = function (format) {
        let o = {
            "M+": this.getMonth() + 1, //month
            "d+": this.getDate(), //day
            "h+": this.getHours(), //hour
            "m+": this.getMinutes(), //minute
            "s+": this.getSeconds(), //second
            "q+": Math.floor((this.getMonth() + 3) / 3), //quarter
            "S": this.getMilliseconds() //millisecond
        };
        if (/(y+)/.test(format)) format = format.replace(RegExp.$1,
            (this.getFullYear() + "").substr(4 - RegExp.$1.length));
        for (let k in o) if (new RegExp("(" + k + ")").test(format))
            format = format.replace(RegExp.$1,
                RegExp.$1.length == 1 ? o[k] :
                    ("00" + o[k]).substr(("" + o[k]).length));
        return format;
    };
    let util = {
		antcoorMsg: function ($, msg, width, height, title) {
            $(document.body).append('<div id="antcoor-msg-container">' +
                '<div id="antcoor-msg-panel" style="left:0;top:0;right:0;bottom:0;position:fixed;z-index:99999998;background-color: #000;opacity: 0.5">' +
                '</div><div style="left:0;right:0;top:0;bottom:0;position:fixed;z-index:99999999;display: flex;justify-content: center;align-items: center">' +
                '<div style="width: ' + (width || 300) + 'px;height:' + (height || 150) + 'px;display: flex;flex-direction: column;background-color: #fff;border-radius: 5px;justify-content: center;align-items: center">' +
                '<div style="height:32px;background-color: #f5f5f5;border-bottom: 1px solid #eee;width:100%;border-top-right-radius: 5px;border-top-left-radius: 5px;padding-left:10px;line-height:32px">' + (title || '温馨提示') + '</div>' +
                '<div style="flex:1;display: flex;justify-content: center;align-items: center;font-size:15px;padding:10px 15px;font-size:15px;color:#555;line-height: 150%">' + msg + '</div>' +
                '<div style="height:50px;display: flex;justify-content: center;align-items: center">' +
                '<button class="ac-btn ac-btn-main" id="antcoor-msg-panel-close">关闭</button></div>' +
                '</div></div></div>');
            $('#antcoor-msg-panel-close').click(function () {
                $(document.body).find('#antcoor-msg-container').remove();
            });
        },
		showLoading: function ($, query, timeout) {
            $(query || '.antcoor-loading').empty().append('<img style="width:50px;height:50px" src="' + chrome.extension.getURL('static/images/loading.gif') + '" />');
            $(query || '.antcoor-loading').css("display", "flex");
            setTimeout(function () {
                util.hideLoading($, query)
            }, timeout || 10000)
        },
        hideLoading: function ($, query) {
            $(query || '.antcoor-loading').hide();
        },
		getAntcoorToken: function(cb) {
			chrome.storage.local.get(['antcoorToken'], function (result) {
				if (result.antcoorToken) {
					cb(result.antcoorToken);
					return;
				}
				cb(false);
			});
		},
        getLocaleDateFormat:function(locale) {
            if(locale=='en-us') {
                return 'MMMM D, YYYY';
            } else if(locale=='es-mx') {
                return 'D MMMM YYYY';
            } else if(locale=='es-us') {
                return 'MMMM D, YYYY';
            } else if(locale=='it-it') {
                return 'D MMMM YYYY';
            } else if(locale=='fr-fr') {
                return 'D MMMM YYYY';
            } else if(locale=='ja-jp') {
                return 'YYYY/M/D';
            } else if(locale=='de-de') {
                return 'D MMMM YYYY';
            } else if(locale=='en-gb') {
                return 'D MMMM YYYY';
            } else if(locale=='es-es') {
                return 'D MMMM YYYY';
            } else if(locale=='pt-pt') {
                return 'D MMMM YYYY';
            } else if(locale=='nl-nl') {
                return 'D MMMM YYYY';
            } else if(locale=='tr-tr') {
                return 'D MMMM YYYY';
            } else if(locale=='cs-cz') {
                return 'D MMMM YYYY';
            } else if(locale=='en-ca') {
                return 'MMMM D YYYY';
            } else if(locale=='zh-cn') {
                return 'YYYY年M月D日';
            }else {
                return 'D MMMM YYYY';
            }
        },
        getCommonPart:function(str1,str2) {
            //str1=str1.replace(/[\s-_'’"]/g,'');
            //str2=str2.replace(/[\s-_'’"]/g,'');
            let i, j,part,maxlen=0,result;
            for (i = 0; i < str1.length - 1; i++) {
                for (j = i + 1; j <= str1.length; j++) {
                    part = str1.slice(i, j);
                    if (str2.indexOf(part) !== -1) {
                        if(part.length>maxlen) {
                            result=part;
                            maxlen=result.length;
                        }
                    }
                }
            }
            return result;
        },
        parseLocaleMainRank: function (mainRankInfo, href,text,lang) {
            let m = href.match(/\/gp\/bestsellers\/(.*?)\//);
            if (lang.startsWith('en-')) {
                let rankArr = mainRankInfo.split('(')[0].split(' in ');
                return rankArr.length>1?[rankArr[0].replace(/\D/g, ''), rankArr[1], m[1]]:false;
            } else if (lang.startsWith('ja-')) {
                let rankArr = mainRankInfo.split('(')[0].split('位');
                return rankArr.length>1?[rankArr[0].replace(/[\s,-]/g, '').trim(), rankArr[1].trim(), m[1]]:false;
            } else if (lang.startsWith('es-')) {
                let rankArr = mainRankInfo.split('(')[0].split(' en ');
                return rankArr.length>1?[rankArr[0].replace(/\D/g, ''), rankArr[1].trim(), m[1]]:false;
            } else if (lang.startsWith('fr-')) {
                let rankArr = mainRankInfo.split('(')[0].split(' en ');
                return rankArr.length>1?[rankArr[0].replace(/\D/g, ''), rankArr[1]||text, m[1]]:false;
            } else if (lang.startsWith('it-') || lang.startsWith('de-') || lang.startsWith('nl-')) {
                let rankArr = mainRankInfo.split('(')[0].split(' in ');
                return rankArr.length>1?[rankArr[0].replace(/\D/g, ''), rankArr[1]||text, m[1]]:false;
            } else if (lang.startsWith('pt-')) {
                let rankArr = mainRankInfo.split('(')[0].split(' em ');
                return rankArr.length>1?[rankArr[0].replace(/\D/g, ''), rankArr[1].trim(), m[1]]:false;
            } else if (lang.startsWith('zh-')) {
                let rankArr = mainRankInfo.split('(')[0].split('名');
                return rankArr.length>1?[rankArr[0].replace(/\D/g, '').trim(), rankArr[1].trim(), m[1]]:false;
            }
        },
        parseLocaleRank: function (rankStr,lang) {
            if (lang.startsWith('en-')) {
                let arr = rankStr.split(/\sin\s/);
                return [arr[0].replace(/\D/g, ''), arr[1].trim()];
            } else if (lang.startsWith('ja-')) {
                let rankArr = rankStr.split('位');
                return [rankArr[0].replace(/[\s,-]/g, '').trim(), rankArr[1].trim()];
            } else if (lang.startsWith('es-')) {
                let arr = rankStr.split(/\sen\s/);
                return [arr[0].replace(/\D/g, ''), arr[1].trim()];
            } else if (lang.startsWith('fr-')) {
                let arr = rankStr.split(/\sen\s/);
                return [arr[0].replace(/\D/g, ''), arr[1].trim()];
            } else if (lang.startsWith('it-') || lang.startsWith('de-') || lang.startsWith('nl-')) {
                let arr = rankStr.split(/\sin\s/);
                return [arr[0].replace(/\D/g, ''), arr[1].trim()];
            } else if (lang.startsWith('pt-')) {
                let arr = rankStr.split(' em ');
                return [arr[0].replace(/\D/g, ''), arr[1].trim()];
            } else if (lang.startsWith('zh-')) {
                let rankArr = rankStr.split('名');
                return [rankArr[0].replace(/\D/g, '').trim(), rankArr[1].trim()];
            }
        },
        parseLocaleNumber: function (stringNumber, locale) {
            var thousandSeparator = Intl.NumberFormat(locale).format(11111).replace(/\p{Number}/gu, '');
            var decimalSeparator = Intl.NumberFormat(locale).format(1.1).replace(/\p{Number}/gu, '');

            return parseFloat(stringNumber
                .replace(new RegExp('\\' + thousandSeparator, 'g'), '')
                .replace(new RegExp('\\' + decimalSeparator), '.')
            );
        },
        getCurr: function (symbol) {
            if (symbol == '$') {
                if (this.getLocale() == 'au') {
                    return 'AUD';
                }
                return 'USD';
            } else if (symbol == '£') {
                return 'GBP';
            } else if (symbol == '€') {
                return 'EUR';
            } else if (symbol == 'R$') {
                return 'BRL';
            } else if (symbol == '¥' || symbol == '￥' || symbol == 'JP¥') {
                return 'JPY';
            } else if (symbol == '₹') {
                return 'INR';
            } else if (symbol == 'S$') {
                return 'SGD';
            } else if (symbol == 'kr') {
                return 'AED';
            } else if (symbol == 'TL') {
                return 'TRY';
            }
            return 'USD';
        },
        log:function(s) {
            console.log(new Date().format('hh:mm:ss'),s);
        }
    }
    return util;
})))
